/***************************************************************************
openBibleViewer - Bible Study Tool
Copyright (C) 2009-2012 Paul Walger <metaxy@walger.name>
This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.
This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with
this program; if not, see <http://www.gnu.org/licenses/>.
*****************************************************************************/
#ifndef CONTEXT_H
#define CONTEXT_H

#include "src/core/basicclass.h"
#include "src/core/settings/settingsloader.h"
#include "mainwindow.h"
class Context : public QObject, public BasicClass
{
    Q_OBJECT
public:
    explicit  Context(QObject *parent);
    ~Context();

    void init();

    void setSettings(QSettings *settings);
    void setHomePath(const QString &homePath);
    void setTranslator(QTranslator *my, QTranslator *qt);

    void showWindow();

    void writeSettings();

private slots:
    void toggleFullScreen();
private:
    QSettings *m_settingsFile;
    QString m_homeDataPath;
    QTranslator *m_myappTranslator;
    QTranslator *m_qtTranslator;

    bool m_firstStart;
    SettingsLoader *m_settingsLoader;
    MainWindow *m_window;
};

#endif // CONTEXT_H
